package com.ruoyi.project.business.domain;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.framework.aspectj.lang.annotation.Excel;
import com.ruoyi.framework.web.domain.BaseEntity;

/**
 * 【请填写功能名称】对象 tq_quotation
 * 
 * @author ruoyi
 * @date 2024-05-10
 */
public class TqQuotation extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** ID */
    private Long id;

    /** 报价编号 */
    @Excel(name = "报价编号")
    private String quotationNo;

    /** 报价版本（版本从1递增） */
    @Excel(name = "报价版本", readConverterExp = "版=本从1递增")
    private Long version;

    /** 代理商ID */
    @Excel(name = "代理商ID")
    private Long agentId;

    /** 项目ID */
    @Excel(name = "项目ID")
    private Long projectId;

    /** 报价单币种 */
    @Excel(name = "报价单币种")
    private Long currencyId;

    /** 报价单币种汇率 */
    @Excel(name = "报价单币种汇率")
    private BigDecimal exchangeRate;

    /** 价格(系统计算价格的合计价格) */
    @Excel(name = "价格(系统计算价格的合计价格)")
    private BigDecimal price;

    /** 最终价格 */
    @Excel(name = "最终价格")
    private BigDecimal finalPrice;

    /** 运费 */
    @Excel(name = "运费")
    private BigDecimal freightPrice;

    /** 基础价格 */
    @Excel(name = "基础价格")
    private BigDecimal basicPrice;

    /** 选配价格 */
    @Excel(name = "选配价格")
    private BigDecimal optionalPrice;

    /** 报价状态（数据字典） */
    @Excel(name = "报价状态", readConverterExp = "数=据字典")
    private String quotationStatus;

    /** 提交时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "提交时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date submitTime;

    /** 成单时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "成单时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date orderTime;

    /** 系统评审结果（00：标准 01：非标准） */
    @Excel(name = "系统评审结果", readConverterExp = "0=0：标准,0=1：非标准")
    private String systemCheckResult;

    /** 数据权限字符 */
    @Excel(name = "数据权限字符")
    private String permissionChar;

    /** 删除标记（0：未删除  1：已删除） */
    private String delFlag;

    public void setId(Long id) 
    {
        this.id = id;
    }

    public Long getId() 
    {
        return id;
    }
    public void setQuotationNo(String quotationNo) 
    {
        this.quotationNo = quotationNo;
    }

    public String getQuotationNo() 
    {
        return quotationNo;
    }
    public void setVersion(Long version) 
    {
        this.version = version;
    }

    public Long getVersion() 
    {
        return version;
    }
    public void setAgentId(Long agentId) 
    {
        this.agentId = agentId;
    }

    public Long getAgentId() 
    {
        return agentId;
    }
    public void setProjectId(Long projectId) 
    {
        this.projectId = projectId;
    }

    public Long getProjectId() 
    {
        return projectId;
    }
    public void setCurrencyId(Long currencyId) 
    {
        this.currencyId = currencyId;
    }

    public Long getCurrencyId() 
    {
        return currencyId;
    }
    public void setExchangeRate(BigDecimal exchangeRate) 
    {
        this.exchangeRate = exchangeRate;
    }

    public BigDecimal getExchangeRate() 
    {
        return exchangeRate;
    }
    public void setPrice(BigDecimal price) 
    {
        this.price = price;
    }

    public BigDecimal getPrice() 
    {
        return price;
    }
    public void setFinalPrice(BigDecimal finalPrice) 
    {
        this.finalPrice = finalPrice;
    }

    public BigDecimal getFinalPrice() 
    {
        return finalPrice;
    }
    public void setFreightPrice(BigDecimal freightPrice) 
    {
        this.freightPrice = freightPrice;
    }

    public BigDecimal getFreightPrice() 
    {
        return freightPrice;
    }
    public void setBasicPrice(BigDecimal basicPrice) 
    {
        this.basicPrice = basicPrice;
    }

    public BigDecimal getBasicPrice() 
    {
        return basicPrice;
    }
    public void setOptionalPrice(BigDecimal optionalPrice) 
    {
        this.optionalPrice = optionalPrice;
    }

    public BigDecimal getOptionalPrice() 
    {
        return optionalPrice;
    }
    public void setQuotationStatus(String quotationStatus) 
    {
        this.quotationStatus = quotationStatus;
    }

    public String getQuotationStatus() 
    {
        return quotationStatus;
    }
    public void setSubmitTime(Date submitTime) 
    {
        this.submitTime = submitTime;
    }

    public Date getSubmitTime() 
    {
        return submitTime;
    }
    public void setOrderTime(Date orderTime) 
    {
        this.orderTime = orderTime;
    }

    public Date getOrderTime() 
    {
        return orderTime;
    }
    public void setSystemCheckResult(String systemCheckResult) 
    {
        this.systemCheckResult = systemCheckResult;
    }

    public String getSystemCheckResult() 
    {
        return systemCheckResult;
    }
    public void setPermissionChar(String permissionChar) 
    {
        this.permissionChar = permissionChar;
    }

    public String getPermissionChar() 
    {
        return permissionChar;
    }
    public void setDelFlag(String delFlag) 
    {
        this.delFlag = delFlag;
    }

    public String getDelFlag() 
    {
        return delFlag;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("quotationNo", getQuotationNo())
            .append("version", getVersion())
            .append("agentId", getAgentId())
            .append("projectId", getProjectId())
            .append("currencyId", getCurrencyId())
            .append("exchangeRate", getExchangeRate())
            .append("price", getPrice())
            .append("finalPrice", getFinalPrice())
            .append("freightPrice", getFreightPrice())
            .append("basicPrice", getBasicPrice())
            .append("optionalPrice", getOptionalPrice())
            .append("quotationStatus", getQuotationStatus())
            .append("submitTime", getSubmitTime())
            .append("orderTime", getOrderTime())
            .append("systemCheckResult", getSystemCheckResult())
            .append("permissionChar", getPermissionChar())
            .append("delFlag", getDelFlag())
            .append("createTime", getCreateTime())
            .append("createBy", getCreateBy())
            .append("updateTime", getUpdateTime())
            .append("updateBy", getUpdateBy())
            .append("remark", getRemark())
            .toString();
    }
}
