package com.ruoyi.project.business.enums;

import com.ruoyi.common.exception.ServiceErrorException;
import lombok.AllArgsConstructor;
import lombok.Getter;

@AllArgsConstructor
@Getter
public enum AuditStatusEnum {

    /**
     * 草稿
     */
    DRAFT(0, "草稿"),
    WAITING_UPLOAD(10, "待上传"),
    REJECT(30, "已驳回"),
    ROLLBACK(40, "已撤回"),
    AUDITING(100, "审核中"),
    AUDITOR_ONE(101, "一级审核"),
    AUDITOR_TWO(102, "二级审核"),
    PASS(200, "已通过");

    private Integer value;
    private String desc;

    public static AuditStatusEnum from(Integer value) {
        for (AuditStatusEnum auditFlowEnum : values()) {
            if (auditFlowEnum.getValue().equals(value)) {
                return auditFlowEnum;
            }
        }
        throw new ServiceErrorException("非法的审批状态");
    }

    public static AuditStatusEnum fromDesc(String value) {
        for (AuditStatusEnum auditFlowEnum : values()) {
            if (auditFlowEnum.getDesc().equals(value)) {
                return auditFlowEnum;
            }
        }
        throw new ServiceErrorException("非法的审批状态");
    }

    public static AuditStatusEnum fromByCode(String value) {
        for (AuditStatusEnum auditFlowEnum : values()) {
            if (auditFlowEnum.getValue().toString().equals(value)) {
                return auditFlowEnum;
            }
        }
        throw new ServiceErrorException("非法的审批状态");
    }

    public static AuditStatusEnum fromDescOut(String value) {
        for (AuditStatusEnum auditFlowEnum : values()) {
            if (auditFlowEnum.getDesc().equals(value)) {
                return auditFlowEnum;
            }
        }
        return null;
    }

    public static AuditStatusEnum fromByCodeOut(String value) {
        for (AuditStatusEnum auditFlowEnum : values()) {
            if (auditFlowEnum.getValue().toString().equals(value)) {
                return auditFlowEnum;
            }
        }
        return null;
    }

    /**
     * 100~200分配给扩展的审核节点
     *
     * @param value
     * @return
     */
    public static boolean isAuditing(Integer value) {
        return value >= 100 && value < 200;
    }
}
