package com.ruoyi.project.business.service.flow;

import com.ruoyi.project.business.domain.flow.Flow;
import com.ruoyi.project.business.domain.flow.FlowAuditParam;
import com.ruoyi.project.business.domain.flow.FlowConfig;
import com.ruoyi.project.business.domain.flow.FlowTaskUser;
import com.ruoyi.project.business.dto.TaskGenerateParams;
import com.ruoyi.project.business.enums.AuditFlowEnum;
import com.ruoyi.project.business.enums.CategoryEnum;
import com.ruoyi.project.business.enums.FunctionEnum;
import com.ruoyi.project.business.enums.ModuleEnum;

import java.util.List;
import java.util.Map;

/**
 * 【请填写功能名称】Service接口
 *
 * @author generator
 * @date 2021-09-28
 */
public interface IFlowService {

    /************************************ ↓流程配置相关接口↓ *******************************************/

    /**
     * 保存审批流程配置
     *
     * @param flowConfig
     * @return
     */
    int saveConfig(FlowConfig flowConfig);

    /**
     * 获取审批流程配置
     *
     * @param flowConfig
     * @return
     */
    FlowConfig getConfig(FlowConfig flowConfig);

    /**
     * 清除自定义审批流程
     *
     * @param flowConfig
     * @return
     */
    int removeConfig(FlowConfig flowConfig);

    /************************************ ↓流程生成相关接口↓ *******************************************/

    /**
     * 审批任务生成
     *
     * @param taskGenerateParams 流程生成参数
     */
    boolean generateTasks(TaskGenerateParams taskGenerateParams);


    /************************************ ↓流程审批相关接口↓ *******************************************/

    Map<Integer, Flow> getFlowMap(List<Integer> ids, AuditFlowEnum auditFlow);

    Map<Integer, Flow> getFlowMap(List<Integer> ids, List<AuditFlowEnum> auditFlows);

    int remove(AuditFlowEnum auditFlow, List<Long> businessIds);

    boolean audit(FlowAuditParam auditParam);

    boolean auditBatch(FlowAuditParam auditParam);

    boolean rollback(FlowAuditParam auditParam);

    List<FlowTaskUser> getAuditHistory(List<AuditFlowEnum> auditFlows, Integer businessId, ModuleEnum module, FunctionEnum func, CategoryEnum category);

}
