package com.ruoyi.project.business.service.quotation.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.project.business.domain.TqSpecificationDetail;
import com.ruoyi.project.business.domain.TqSpecificationParabarDetail;
import com.ruoyi.project.business.domain.vo.quotation.SpecificationParamVO;
import com.ruoyi.project.business.domain.vo.quotation.SpecificationVO;
import com.ruoyi.project.business.enums.ParamTypeEnum;
import com.ruoyi.project.business.mapper.quotation.TqSpecificationParabarDetailMapper;
import com.ruoyi.project.business.service.quotation.ITqSpecificationDetailService;
import java.util.ArrayList;
import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import java.util.Map;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.project.business.mapper.quotation.TqSpecificationMapper;
import com.ruoyi.project.business.domain.TqSpecification;
import com.ruoyi.project.business.service.quotation.ITqSpecificationService;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2024-05-10
 */
@Service
public class TqSpecificationServiceImpl extends ServiceImpl<TqSpecificationMapper, TqSpecification> implements
    ITqSpecificationService {

    @Resource
    private TqSpecificationMapper tqSpecificationMapper;

    @Resource
    private ITqSpecificationDetailService iTqSpecificationDetailService;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public TqSpecification selectTqSpecificationById(Long id) {
        return tqSpecificationMapper.selectTqSpecificationById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param tqSpecification 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<SpecificationVO> selectTqSpecificationList(TqSpecification tqSpecification) {
        List<SpecificationVO> specificationVOS = tqSpecificationMapper.selectSpecificationVOList(tqSpecification);
        specificationVOS.forEach(item -> {
            item.setParamList(new ArrayList<>());
        });
        // 获取电梯的参数配置
        List<Long> collect = specificationVOS.stream().map(TqSpecification::getId).collect(Collectors.toList());
        if (CollUtil.isNotEmpty(collect)) {
            // 普通参数
            List<TqSpecificationDetail> paramList = iTqSpecificationDetailService.list(
                Wrappers.<TqSpecificationDetail>lambdaQuery().in(TqSpecificationDetail::getSpecificationId, collect)
                    .eq(TqSpecificationDetail::getDelFlag, 0)
                    .isNull(TqSpecificationDetail::getParabarId)
            );
            Map<Long, List<TqSpecificationDetail>> paramMap = paramList.stream()
                .collect(Collectors.groupingBy(TqSpecificationDetail::getSpecificationId));
            specificationVOS.forEach(item -> {
                List<TqSpecificationDetail> orDefault = paramMap.getOrDefault(item.getId(), new ArrayList<>());
                item.getParamList()
                    .addAll(orDefault.stream().map(SpecificationParamVO::covertNormal).collect(Collectors.toList()));
            });
            // 参数包参数
            List<TqSpecificationDetail> tqSpecificationDetailList = iTqSpecificationDetailService.list(
                Wrappers.<TqSpecificationDetail>lambdaQuery().in(TqSpecificationDetail::getSpecificationId, collect)
                    .eq(TqSpecificationDetail::getDelFlag, 0)
                    .isNotNull(TqSpecificationDetail::getParabarId)
            );
            Map<Long, List<TqSpecificationDetail>> parabarParamMap = tqSpecificationDetailList.stream()
                .collect(Collectors.groupingBy(TqSpecificationDetail::getSpecificationId));

            specificationVOS.forEach(item -> {
                List<TqSpecificationDetail> orDefault = parabarParamMap.getOrDefault(item.getId(), new ArrayList<>());
                List<SpecificationParamVO> convertList = orDefault.stream().map(SpecificationParamVO::covertParabar)
                    .collect(Collectors.toList());
                item.getParamList().addAll(convertList);
                // 参数包
                List<SpecificationParamVO> parabarParamList = new ArrayList<>();
                Map<Long, List<SpecificationParamVO>> collect1 = convertList.stream()
                    .filter(a -> !"05".equals(a.getParaCategory()))
                    .collect(Collectors.groupingBy(SpecificationParamVO::getParabarDetailId));
                for (Map.Entry<Long, List<SpecificationParamVO>> entry : collect1.entrySet()) {
                    SpecificationParamVO anyOne = entry.getValue().get(0);
                    SpecificationParamVO build = SpecificationParamVO.builder()
                        .paraCategory(anyOne.getParaCategory())
                        .paraCode(anyOne.getParabarId().toString())
                        .paraValue(anyOne.getParabarDetailId().toString())
                        .paramType(ParamTypeEnum.BAR.getCode())
                        .build();
                    parabarParamList.add(build);
                }
                item.getParamList().addAll(parabarParamList);
            });

        }
        return specificationVOS;
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param tqSpecification 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertTqSpecification(TqSpecification tqSpecification) {
        tqSpecification.setCreateTime(DateUtils.getNowDate());
        return tqSpecificationMapper.insertTqSpecification(tqSpecification);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param tqSpecification 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateTqSpecification(TqSpecification tqSpecification) {
        tqSpecification.setUpdateTime(DateUtils.getNowDate());
        return tqSpecificationMapper.updateTqSpecification(tqSpecification);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteTqSpecificationByIds(Long[] ids) {
        return tqSpecificationMapper.deleteTqSpecificationByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteTqSpecificationById(Long id) {
        return tqSpecificationMapper.deleteTqSpecificationById(id);
    }
}
